package orderprocessing;

import java.awt.*;
import java.awt.event.*;
//import java.util.*;
//import java.text.SimpleDateFormat;
//import java.text.ParseException;
/*
* @author TEAM 4
* Created on Nov 8, 2003
*
* created with a little help from my friends
*	CustomerEntry is the GUI to this application for customer entry. 
*/
public class CustomerEntry extends Frame
{	public CustomerEntry()
	{	super("CustomerEntry");
		setName("CustomerEntry");
		setBounds(20, 20, 640, 480);
		saveCustomerInfo= false;
		addWindowListener
		(	new WindowAdapter() // Anonymous inner class
			{	public void windowClosing(WindowEvent e)
				{	if(saveCustomerInfo)
					{	OrderProcessor.close(OrderProcessor.databaseName()); // Do this when you want customer info  saved. 
					   
					}			
					System.exit(0);
				}    
			}
		);
		GridBagLayout layout = new GridBagLayout();
		setLayout(layout);
		add(new Label("New Customer Entry"), 1,0,1,1,0.0, 1.0);
       
		customerNumber.setEnabled(false);
		CustomerNameListener cust = new CustomerNameListener();
		customerName.addActionListener(cust);

		billingName.setEnabled(true);
//		BillingNameListener bname = new BillingNameListener();
//		billingName.addActionListener(bname);

		billingStreet.setEnabled(true);
//		BillingStreetListener bstreet = new BillingStreetListener();
//		billingStreet.addActionListener(bstreet);
				
		billingCity.setEnabled(true);
//		BillingCityListener bcity = new BillingCityListener();
//		billingCity.addActionListener(bcity);
		
		billingState.setEnabled(true);
//		BillingStateListener bstate = new BillingStateListener();
//		billingState.addActionListener(bstate);
		
		billingZip.setEnabled(true);
//		BillingZipListener bzip = new BillingZipListener();
//		billingZip.addActionListener(bzip);
		
      /* TODO Refactor out an AddressPanel to hold an address.
       Put the labels to the left of the fields when you do this. 
       */
		add(new Label("Customer Number"), 0,1,1,1,0.0,0.0 );
		add(customerNumber, 1,1,1,1,0.0, 1.0);
		customerNumber.setName("CEcustomerNumber");
		add(new Label("Will Be Assigned"), 2, 1, 1,1,0.0,0.0);
		add(new Label("Customer Name"), 0, 2, 1,1,0.0,0.0);
		add(customerName, 1,2,1,1,0.0, 1.0);
		customerName.setName("CEcustomerName");
		add(new Label("Billing Address"), 0, 3, 1,1,0.0,0.0);
		add(billingName, 1,3,1,1,0.0, 1.0);
		billingName.setName("CEbillingName");
		add(new Label("Name"), 2, 3, 1,1,0.0,0.0);	
		add(billingStreet,1,4,1,1,0.0, 1.0);
		billingStreet.setName("CEbillingStreet");
		add(new Label("Street"), 2, 4, 1,1,0.0,0.0);
		add(billingCity, 1,5,1,1,0.0, 1.0);
		billingCity.setName("CEbillingCity");
		add(new Label("City"), 2, 5, 1,1,0.0,0.0);
		add(billingState,1,6,1,1,0.0, 1.0);
		billingState.setName("CEbillingState");
		add(new Label("State"), 2, 6, 1,1,0.0,0.0);
		add(billingZip, 1,7,1,1,0.0, 1.0);
		billingZip.setName("CEbillingZip");
		add(new Label("Zip"), 2, 7, 1,1,0.0,0.0);
		add(new Label(""), 2, 8, 1,1,0.0,0.0);	
		add(new Label("Shipping Address"), 0, 9, 1,1,0.0,0.0);
		add(shippingName,   1,9,1,1,0.0, 1.0);
		shippingName.setName("CEshippingName");
		add(new Label("Name"), 2, 9, 1,1,0.0,0.0);	
		add(sameAddress,   0,10,1,1,0.0, 1.0);
		sameAddress.setName("CEsameAddress");
		add(shippingStreet,   1,10,1,1,0.0, 1.0);
		shippingStreet.setName("CEshippingStreet");
		add(new Label("Street"), 2, 10, 1,1,0.0,0.0);
		add(shippingCity,   1,11,1,1,0.0, 1.0);
		shippingCity.setName("CEshippingCity");
		add(new Label("City"), 2, 11, 1,1,0.0,0.0);
		add(shippingState,   1,12,1,1,0.0, 1.0);
		shippingState.setName("CEshippingState");
		add(new Label("State"), 2, 12, 1,1,0.0,0.0);
		add(shippingZip,   1,13,1,1,0.0, 1.0);
		shippingZip.setName("CEshippingZip");
		add(new Label("Zip"), 2, 13, 1,1,0.0,0.0);
		add(new Label("Billing Terms"), 0,14,1,1,0.0,0.0 );
		billingTerms.add("Default");
		billingTerms.add("NET 10");
		billingTerms.add("NET 30");
		billingTerms.add("EOM 10");
		add(billingTerms,1,14,1,1,0.0,0.0);
		billingTerms.setName("CEbillingTerms");
		add(accept, 0,20,1,1,0.0,0.0 );
		accept.setName("CEaccept");
		add(reset, 1,20,1,1,0.0,0.0 );
		reset.setName("CEreset");
		add(writeDB, 2,20,1,1,0.0,0.0 );
		writeDB.setName("CEwriteDB");
		originalDBColor = writeDB.getBackground();
		writeDB.setBackground(Color.yellow);
        
		sameAddress.addActionListener(new SameAddressListener());
		accept.addActionListener(new AcceptListener());
		writeDB.addActionListener(new WriteDBListener());
		reset.addActionListener(new ResetListener());
		setBackground(new Color(5, 230, 170));
		setVisible(true);		
	}
    
	private void add(Component arg, int x, int y, int h, int v, double wx, double wy)
	{	GridBagLayout gbl = (GridBagLayout)getLayout();
		GridBagConstraints c = new GridBagConstraints();
		c.fill = GridBagConstraints.NONE;
		c.gridx = x;
		c.gridy = y;
		c.gridwidth = h;
		c.gridheight = v;
		c.weightx = wx;
		c.weighty = wy;
		gbl.setConstraints(arg, c);
		add(arg);
	}
    
   private boolean saveCustomerInfo = false;
   private TextField customerNumber = new TextField(10);
   private TextField customerName = new TextField(45);
   private TextField billingName = new TextField(45);
   private TextField billingStreet = new TextField(45);
   private TextField billingCity = new TextField(45);
   private TextField billingState = new TextField(45);
   private TextField billingZip = new TextField(45);
   private TextField shippingName = new TextField(45);
   private TextField shippingStreet = new TextField(45);
   private TextField shippingCity = new TextField(45);
   private TextField shippingState = new TextField(45);
   private TextField shippingZip = new TextField(45);
   private Choice billingTerms = new Choice();
   private Button sameAddress = new Button("Same as Above");
   private Button accept = new Button("Accept Customer");
   private Button writeDB = new Button("Save Database At Exit");
   private Button reset = new Button("Reset");
   private Color originalDBColor = null;
   
   
   private class CustomerNameListener implements ActionListener
	{	public void actionPerformed(ActionEvent e)
		{
			String custName = customerName.getText().trim();
			billingName.setText(custName);
			shippingName.setText(custName);
			customerName.requestFocus();
		}
	}

//	private class BillingNameListener implements ActionListener
//	{	public void actionPerformed(ActionEvent e)
//		{
//			shippingName.setText(billingName.getText());           
//		}
//	}
//
//	private class BillingStreetListener implements ActionListener
//	{	public void actionPerformed(ActionEvent e)
//		{
//
//			shippingStreet.setText(billingStreet.getText());
//           
//		}
//	}
//	
//	private class BillingCityListener implements ActionListener
//	{	public void actionPerformed(ActionEvent e)
//		{
//			shippingCity.setText(billingCity.getText());
//           
//		}
//	}
//	
//	private class BillingStateListener implements ActionListener
//	{	public void actionPerformed(ActionEvent e)
//		{
//
//			shippingState.setText(billingState.getText());
//           
//		}
//	}
//	
//	private class BillingZipListener implements ActionListener
//	{	public void actionPerformed(ActionEvent e)
//		{
//
//			shippingZip.setText(billingZip.getText() );
//           
//		}
//	}
	
	private class AcceptListener implements ActionListener
	{	public void actionPerformed(ActionEvent e)
		{	String cName = customerName.getText().trim();
			if (cName.equals(""))
			{	customerName.setText("Required field");
				customerName.selectAll();
				customerName.requestFocus();
				return;
			}		
			String billName = billingName.getText().trim();
			if (billName.equals(""))
			{	billingName.setText("Required field");
				billingName.selectAll();
				billingName.requestFocus();
				return;
			}		
			String billStreet = billingStreet.getText();
			if (billStreet.equals(""))
			{	billingStreet.setText("Required field");
				billingStreet.selectAll();
				billingStreet.requestFocus();
				return;
			}		
			String billCity = billingCity.getText().trim();
			if (billCity.equals(""))
			{	billingCity.setText("Required field");
				billingCity.selectAll();
				billingCity.requestFocus();
				return;
			}		
			String billState = billingState.getText().trim();
			if (billState.equals(""))
			{	billingState.setText("Required field");
				billingState.selectAll();
				billingState.requestFocus();
				return;
			}		
			String billZip = billingZip.getText().trim();
			if (billZip.equals(""))
			{	billingZip.setText("Required field");
				billingZip.selectAll();
				billingZip.requestFocus();
				return;
			}		
			String shipName = shippingName.getText().trim();
			if (shipName.equals(""))
			{	shippingName.setText("Required field");
				shippingName.selectAll();
				shippingName.requestFocus();
				return;
			}		
			
			String shipStreet = shippingStreet.getText().trim();
			if (shipStreet.equals(""))
			{	shippingStreet.setText("Required field");
				shippingStreet.selectAll();
				shippingStreet.requestFocus();
				return;
			}		
			String shipCity = shippingCity.getText().trim();
			if (shipCity.equals(""))
			{	shippingCity.setText("Required field");
				shippingCity.selectAll();
				shippingCity.requestFocus();
				return;
			}		
			String shipState = shippingState.getText().trim();
			if (shipState.equals(""))
			{	shippingState.setText("Required field");
				shippingState.selectAll();
				shippingState.requestFocus();
				return;
			}		
			String shipZip = shippingZip.getText().trim();
			if (shipZip.equals(""))
			{	shippingZip.setText("Required field");
				shippingZip.selectAll();
				shippingZip.requestFocus();
				return;
			}		
			String billTerms = billingTerms.getSelectedItem();
			
			shipName = shippingName.getText().trim();
			shipStreet = shippingStreet.getText().trim();
			shipCity = shippingCity.getText().trim();
			shipState = shippingState.getText().trim();
			shipZip = shippingZip.getText().trim();
			
		
			Address billingAddress = new Address(billName, billStreet, billCity, billState, billZip);
			Address shippingAddress = new Address(shipName, shipStreet, shipCity, shipState, shipZip);
	
			Customer newcust = new Customer(cName, billingAddress, shippingAddress);
			customerNumber.setText(newcust.key());	
			
		}
	}
	
	 private class ResetListener implements ActionListener
	 {	public void actionPerformed(ActionEvent e)
		{
			customerNumber.setText("");
			customerName.setText("");
			shippingName.setText("");
			shippingStreet.setText("");
			shippingCity.setText("");
			shippingState.setText("");
			shippingZip.setText("");
			billingName.setText("");
			billingStreet.setText("");
			billingCity.setText("");	
			billingState.setText("");
			billingZip.setText("");	
			billingTerms.select("Default");															
		}
    
	 }
	 
	 private class SameAddressListener implements ActionListener
	 {	public void actionPerformed(ActionEvent e)
		{
			shippingName.setText(billingName.getText().trim());
			shippingStreet.setText(billingStreet.getText().trim());
			shippingCity.setText(billingCity.getText().trim());
			shippingState.setText(billingState.getText().trim());
			shippingZip.setText(billingZip.getText().trim());													
		}
    
	 }
  	
	private class WriteDBListener implements ActionListener
	{	public void actionPerformed(ActionEvent e)
 
		{        
		   if(saveCustomerInfo==false )   
		   {	writeDB.setBackground(originalDBColor);
		   		writeDB.setLabel("Discard Database at Exit");
				saveCustomerInfo=true;
				
		   }
		   else 
		   {	writeDB.setBackground(Color.yellow);
				saveCustomerInfo=false;
				writeDB.setLabel("Save Database at Exit");	
		   }
		   
		}
	}
    

	public static void main(final String [] args)
	{	OrderProcessor.open(OrderProcessor.databaseName());
		new CustomerEntry();
	}
	
}


